Index: palm/trunk/SOURCE/pmc_handle_communicator_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_handle_communicator_mod.f90	(revision 1932)
+++ palm/trunk/SOURCE/pmc_handle_communicator_mod.f90	(revision 1933)
@@ -1,5 +1,5 @@
  MODULE PMC_handle_communicator
 
-!--------------------------------------------------------------------------------!
+!-------------------------------------------------------------------------------!
 ! This file is part of PALM.
 !
@@ -16,13 +16,17 @@
 !
 ! Copyright 1997-2016 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------!
+!-------------------------------------------------------------------------------!
 !
 ! Current revisions:
 ! ------------------
 ! 
-!
+! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+!
+! 1901 2016-05-04 15:39:38Z raasch
+! Initial version of purely vertical nesting introduced.
+! Code clean up. The words server/client changed to parent/child.
 !
 ! 1900 2016-05-04 15:27:53Z raasch
@@ -70,5 +74,5 @@
 ! ------------
 ! Handle MPI communicator in PALM model coupler
-!------------------------------------------------------------------------------!
+!-------------------------------------------------------------------------------!
 
 #if defined( __parallel )
@@ -81,6 +85,8 @@
 #endif
 
-    USE pmc_general,                                                           &
+    USE pmc_general,                                                            &
         ONLY: pmc_status_ok, pmc_status_error, pmc_max_models
+    USE control_parameters,                                                     &
+        ONLY: message_string
 
     IMPLICIT NONE
@@ -113,13 +119,13 @@
 
     INTEGER, PUBLIC ::  m_model_comm          !< communicator of this model
-    INTEGER, PUBLIC ::  m_to_server_comm      !< communicator to the server
+    INTEGER, PUBLIC ::  m_to_parent_comm      !< communicator to the parent
     INTEGER, PUBLIC ::  m_world_rank          !<
     INTEGER         ::  m_world_npes          !<
     INTEGER, PUBLIC ::  m_model_rank          !<
     INTEGER, PUBLIC ::  m_model_npes          !<
-    INTEGER         ::  m_server_remote_size  !< number of server PEs
-
-    INTEGER, DIMENSION(pmc_max_models), PUBLIC ::  m_to_client_comm   !< communicator to the client(s)
-    INTEGER, DIMENSION(:), POINTER, PUBLIC ::  pmc_server_for_client  !<
+    INTEGER         ::  m_parent_remote_size  !< number of parent PEs
+
+    INTEGER, DIMENSION(pmc_max_models), PUBLIC ::  m_to_child_comm    !< communicator to the child(ren)
+    INTEGER, DIMENSION(:), POINTER, PUBLIC ::  pmc_parent_for_child   !<
 
 
@@ -136,16 +142,16 @@
  CONTAINS
 
- SUBROUTINE pmc_init_model( comm, nesting_datatransfer_mode, nesting_mode,     &
+ SUBROUTINE pmc_init_model( comm, nesting_datatransfer_mode, nesting_mode,      &
                               pmc_status )
 
-    USE control_parameters,                                                    &
+    USE control_parameters,                                                     &
         ONLY:  message_string
 
-    USE pegrid,                                                                &
+    USE pegrid,                                                                 &
         ONLY:  myid
 
       IMPLICIT NONE
 
-    CHARACTER(LEN=7), INTENT(OUT) ::  nesting_mode               !<
+    CHARACTER(LEN=8), INTENT(OUT) ::  nesting_mode               !<
     CHARACTER(LEN=7), INTENT(OUT) ::  nesting_datatransfer_mode  !<
 
@@ -153,5 +159,5 @@
     INTEGER, INTENT(OUT) ::  pmc_status  !<
 
-    INTEGER ::  clientcount    !<
+    INTEGER ::  childcount     !<
     INTEGER ::  i              !<
     INTEGER ::  ierr           !<
@@ -160,5 +166,5 @@
     INTEGER ::  tag            !<
 
-    INTEGER, DIMENSION(pmc_max_models)   ::  activeserver  ! I am active server for this client ID
+    INTEGER, DIMENSION(pmc_max_models)   ::  activeparent  ! I am active parent for this child ID
     INTEGER, DIMENSION(pmc_max_models+1) ::  start_pe
 
@@ -167,6 +173,6 @@
     m_world_comm = MPI_COMM_WORLD
     m_my_cpl_id  = -1
-    clientcount  =  0
-    activeserver = -1
+    childcount   =  0
+    activeparent = -1
     start_pe(:)  =  0
 
@@ -177,9 +183,9 @@
     IF ( m_world_rank == 0 )  THEN
 
-       CALL read_coupling_layout( nesting_datatransfer_mode, nesting_mode,     &
+       CALL read_coupling_layout( nesting_datatransfer_mode, nesting_mode,      &
                                   pmc_status )
 
-       IF ( pmc_status /= pmc_no_namelist_found  .AND.                         &
-            pmc_status /= pmc_namelist_error )                                 &
+       IF ( pmc_status /= pmc_no_namelist_found  .AND.                          &
+            pmc_status /= pmc_namelist_error )                                  &
        THEN
 !
@@ -194,8 +200,8 @@
 !--       total sum of cores required by all nest domains
           IF ( start_pe(m_ncpl+1) /= m_world_npes )  THEN
-             WRITE ( message_string, '(A,I6,A,I6,A)' )                         &
-                             'nesting-setup requires more MPI procs (',        &
-                             start_pe(m_ncpl+1), ') than provided (',          &
-                             m_world_npes,')'
+             WRITE ( message_string, '(A,I6,A,I6,A)' )                          &
+                             'nesting-setup requires different number of ',     &
+                             'MPI procs (', start_pe(m_ncpl+1), ') than ',      &
+                             'provided (', m_world_npes,')'
              CALL message( 'pmc_init_model', 'PA0229', 3, 2, 0, 6, 0 )
           ENDIF
@@ -234,20 +240,20 @@
 !-- Broadcast coupling layout
     DO  i = 1, m_ncpl
-       CALL MPI_BCAST( m_couplers(i)%name, LEN( m_couplers(i)%name ),          &
+       CALL MPI_BCAST( m_couplers(i)%name, LEN( m_couplers(i)%name ),           &
                        MPI_CHARACTER, 0, MPI_COMM_WORLD, istat )
-       CALL MPI_BCAST( m_couplers(i)%id,           1, MPI_INTEGER, 0,          &
-                       MPI_COMM_WORLD, istat )
-       CALL MPI_BCAST( m_couplers(i)%Parent_id,    1, MPI_INTEGER, 0,          &
-                       MPI_COMM_WORLD, istat )
-       CALL MPI_BCAST( m_couplers(i)%npe_total,    1, MPI_INTEGER, 0,          &
-                       MPI_COMM_WORLD, istat )
-       CALL MPI_BCAST( m_couplers(i)%lower_left_x, 1, MPI_REAL,    0,          &
-                       MPI_COMM_WORLD, istat )
-       CALL MPI_BCAST( m_couplers(i)%lower_left_y, 1, MPI_REAL,    0,          &
+       CALL MPI_BCAST( m_couplers(i)%id,           1, MPI_INTEGER, 0,           &
+                       MPI_COMM_WORLD, istat )
+       CALL MPI_BCAST( m_couplers(i)%Parent_id,    1, MPI_INTEGER, 0,           &
+                       MPI_COMM_WORLD, istat )
+       CALL MPI_BCAST( m_couplers(i)%npe_total,    1, MPI_INTEGER, 0,           &
+                       MPI_COMM_WORLD, istat )
+       CALL MPI_BCAST( m_couplers(i)%lower_left_x, 1, MPI_REAL,    0,           &
+                       MPI_COMM_WORLD, istat )
+       CALL MPI_BCAST( m_couplers(i)%lower_left_y, 1, MPI_REAL,    0,           &
                        MPI_COMM_WORLD, istat )
     ENDDO
-    CALL MPI_BCAST( nesting_mode, LEN( nesting_mode ), MPI_CHARACTER, 0,       &
+    CALL MPI_BCAST( nesting_mode, LEN( nesting_mode ), MPI_CHARACTER, 0,        &
                     MPI_COMM_WORLD, istat )
-    CALL MPI_BCAST( nesting_datatransfer_mode, LEN(nesting_datatransfer_mode), &
+    CALL MPI_BCAST( nesting_datatransfer_mode, LEN(nesting_datatransfer_mode),  &
                     MPI_CHARACTER, 0, MPI_COMM_WORLD, istat )
 
@@ -255,5 +261,5 @@
 !-- Assign global MPI processes to individual models by setting the couple id
     DO  i = 1, m_ncpl
-       IF ( m_world_rank >= start_pe(i)  .AND.  m_world_rank < start_pe(i+1) ) &
+       IF ( m_world_rank >= start_pe(i)  .AND.  m_world_rank < start_pe(i+1) )  &
        THEN
           m_my_cpl_id = i
@@ -267,5 +273,5 @@
 !-- The communictors for the individual models as created by MPI_COMM_SPLIT.
 !-- The color of the model is represented by the coupler id
-    CALL MPI_COMM_SPLIT( MPI_COMM_WORLD, m_my_cpl_id, m_my_cpl_rank, comm,     &
+    CALL MPI_COMM_SPLIT( MPI_COMM_WORLD, m_my_cpl_id, m_my_cpl_rank, comm,      &
                          istat )
 !
@@ -277,7 +283,7 @@
 !-- Broadcast (from PE 0) the parent id and id of every model
     DO  i = 1, m_ncpl
-       CALL MPI_BCAST( m_couplers(i)%parent_id, 1, MPI_INTEGER, 0,             &
-                       MPI_COMM_WORLD, istat )
-       CALL MPI_BCAST( m_couplers(i)%id,        1, MPI_INTEGER, 0,             &
+       CALL MPI_BCAST( m_couplers(i)%parent_id, 1, MPI_INTEGER, 0,              &
+                       MPI_COMM_WORLD, istat )
+       CALL MPI_BCAST( m_couplers(i)%id,        1, MPI_INTEGER, 0,              &
                        MPI_COMM_WORLD, istat )
     ENDDO
@@ -288,5 +294,5 @@
 
 !
-!-- Create intercommunicator between server and clients.
+!-- Create intercommunicator between parent and children.
 !-- MPI_INTERCOMM_CREATE creates an intercommunicator between 2 groups of
 !-- different colors.
@@ -296,24 +302,23 @@
        IF ( m_couplers(i)%parent_id == m_my_cpl_id )  THEN
 !
-!--       Collect server PEs.
+!--       Collect parent PEs.
 !--       Every model exept the root model has a parent model which acts as
-!--       server model. Create an intercommunicator to connect current PE to
-!--       all client PEs
+!--       parent model. Create an intercommunicator to connect current PE to
+!--       all children PEs
           tag = 500 + i
-          CALL MPI_INTERCOMM_CREATE( comm, 0, MPI_COMM_WORLD, start_pe(i),     &
-                                     tag, m_to_client_comm(i), istat)
-          clientcount = clientcount + 1
-          activeserver(i) = 1
+          CALL MPI_INTERCOMM_CREATE( comm, 0, MPI_COMM_WORLD, start_pe(i),      &
+                                     tag, m_to_child_comm(i), istat)
+          childcount = childcount + 1
+          activeparent(i) = 1
 
        ELSEIF ( i == m_my_cpl_id)  THEN
 !
-!--       Collect client PEs.
-!--       Every model exept the root model has a paremt model which acts as
-!--       server model. Create an intercommunicator to connect current PE to
-!--       all server PEs
+!--       Collect children PEs.
+!--       Every model except the root model has a parent model. 
+!--       Create an intercommunicator to connect current PE to all parent PEs
           tag = 500 + i
-          CALL MPI_INTERCOMM_CREATE( comm, 0, MPI_COMM_WORLD,                  &
-                                     start_pe(m_couplers(i)%parent_id),        &
-                                     tag, m_to_server_comm, istat )
+          CALL MPI_INTERCOMM_CREATE( comm, 0, MPI_COMM_WORLD,                   &
+                                     start_pe(m_couplers(i)%parent_id),         &
+                                     tag, m_to_parent_comm, istat )
        ENDIF
 
@@ -321,25 +326,25 @@
 
 !
-!-- If I am server, count the number of clients that I have
-!-- Although this loop is symmetric on all processes, the "activeserver" flag
+!-- If I am parent, count the number of children that I have
+!-- Although this loop is symmetric on all processes, the "activeparent" flag
 !-- is true (==1) on the respective individual PE only.
-    ALLOCATE( pmc_server_for_client(clientcount+1) )
-
-    clientcount = 0
+    ALLOCATE( pmc_parent_for_child(childcount+1) )
+
+    childcount = 0
     DO  i = 2, m_ncpl
-       IF ( activeserver(i) == 1 )  THEN
-          clientcount = clientcount + 1
-          pmc_server_for_client(clientcount) = i
+       IF ( activeparent(i) == 1 )  THEN
+          childcount = childcount + 1
+          pmc_parent_for_child(childcount) = i
        ENDIF
     ENDDO
 !
-!-- Get the size of the server model
+!-- Get the size of the parent model
     IF ( m_my_cpl_id > 1 )  THEN
-       CALL MPI_COMM_REMOTE_SIZE( m_to_server_comm, m_server_remote_size,      &
+       CALL MPI_COMM_REMOTE_SIZE( m_to_parent_comm, m_parent_remote_size,       &
                                   istat)
     ELSE
 !
-!--    The root model does not have a server
-       m_server_remote_size = -1
+!--    The root model does not have a parent
+       m_parent_remote_size = -1
     ENDIF
 !
@@ -356,6 +361,6 @@
 
 
- SUBROUTINE pmc_get_model_info( comm_world_nesting, cpl_id, cpl_name,          &
-                                cpl_parent_id, lower_left_x, lower_left_y,     &
+ SUBROUTINE pmc_get_model_info( comm_world_nesting, cpl_id, cpl_name,           &
+                                cpl_parent_id, lower_left_x, lower_left_y,      &
                                 ncpl, npe_total, request_for_cpl_id )
 !
@@ -366,7 +371,7 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(OUT), OPTIONAL ::  cpl_name  !<
-
-    INTEGER, INTENT(IN), OPTIONAL ::  request_for_cpl_id  !<
+    CHARACTER(LEN=*), INTENT(OUT), OPTIONAL ::  cpl_name   !<
+
+    INTEGER, INTENT(IN), OPTIONAL ::  request_for_cpl_id   !<
 
     INTEGER, INTENT(OUT), OPTIONAL ::  comm_world_nesting  !<
@@ -433,14 +438,16 @@
 
 
- SUBROUTINE read_coupling_layout( nesting_datatransfer_mode, nesting_mode,     &
+ SUBROUTINE read_coupling_layout( nesting_datatransfer_mode, nesting_mode,      &
                                   pmc_status )
 
     IMPLICIT NONE
 
-    CHARACTER(LEN=7), INTENT(INOUT) ::  nesting_mode
+    CHARACTER(LEN=8), INTENT(INOUT) ::  nesting_mode
     CHARACTER(LEN=7), INTENT(INOUT) ::  nesting_datatransfer_mode
 
-    INTEGER, INTENT(INOUT) ::  pmc_status
-    INTEGER                ::  i, istat
+    INTEGER(iwp), INTENT(INOUT) ::  pmc_status
+    INTEGER(iwp)                ::  bad_llcorner
+    INTEGER(iwp)                ::  i
+    INTEGER(iwp)                ::  istat
 
     TYPE(pmc_layout), DIMENSION(pmc_max_models) ::  domain_layouts
@@ -461,7 +468,9 @@
 
     IF ( istat < 0 )  THEN
+
 !
 !--    No nestpar-NAMELIST found
        pmc_status = pmc_no_namelist_found
+
 !
 !--    Set filepointer to the beginning of the file. Otherwise PE0 will later
@@ -471,4 +480,5 @@
 
     ELSEIF ( istat > 0 )  THEN
+
 !
 !--    Errors in reading nestpar-NAMELIST
@@ -481,4 +491,5 @@
 !-- Output location message
     CALL location_message( 'initialize communicators for nesting', .FALSE. )
+
 !
 !-- Assign the layout to the internally used variable
@@ -490,5 +501,5 @@
 !
 !--    When id=-1 is found for the first time, the list of domains is finished
-       IF ( m_couplers(i)%id == -1  .OR.  i == pmc_max_models )  THEN
+        IF ( m_couplers(i)%id == -1  .OR.  i == pmc_max_models )  THEN
           IF ( m_couplers(i)%id == -1 )  THEN
              m_ncpl = i - 1
@@ -501,4 +512,24 @@
     ENDDO
 
+!
+!-- Make sure that all domains have equal lower left corner in case of vertical
+!-- nesting
+    IF ( nesting_mode == 'vertical' )  THEN
+       bad_llcorner = 0
+       DO  i = 1, m_ncpl
+          IF ( domain_layouts(i)%lower_left_x /= 0.0_wp .OR.                    &
+               domain_layouts(i)%lower_left_y /= 0.0_wp )  THEN
+             bad_llcorner = bad_llcorner + 1
+             domain_layouts(i)%lower_left_x = 0.0_wp
+             domain_layouts(i)%lower_left_y = 0.0_wp
+          ENDIF
+       ENDDO
+       IF ( bad_llcorner /= 0)  THEN
+          WRITE ( message_string, *)  'Lower left corners do not match,',       &
+                                      'they were set to (0, 0)'
+          CALL message( 'read_coupling_layout', 'PA0427', 0, 0, 0, 6, 0 )
+       ENDIF
+    ENDIF
+
  END SUBROUTINE read_coupling_layout
 
